Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::HevyMetl Class Reference

STK heavy metal FM synthesis instrument. More...

`#include <HevyMetl.h>`

Inheritance diagram for stk::HevyMetl:

List of all members.

## Public Member Functions
| HevyMetl (void)
| Class constructor.
| ~HevyMetl (void)
| Class destructor.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK heavy metal FM synthesis instrument.

This class implements 3 cascade operators with feedback modulation, also referred to as algorithm 3 of the TX81Z.

        Algorithm 3 is :    4--\
                        3-->2-- + -->1-->Out

Control Change Numbers:

- Total Modulator Index = 2
- Modulator Crossfade = 4
- LFO Speed = 11
- LFO Depth = 1
- ADSR 2 & 4 Target = 128

The basic Chowning/Stanford FM patent expired in 1995, but there exist follow-on patents, mostly assigned to Yamaha. If you are of the type who should worry about this (making money) worry away.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::HevyMetl::HevyMetl | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::HevyMetl::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::FM.

    00098 {
    00099   unsigned int nChannels = lastFrame_.channels();
    00100 #if defined(_STK_DEBUG_)
    00101   if ( channel > frames.channels() - nChannels ) {
    00102     oStream_ << "HevyMetl::tick(): channel and StkFrames arguments are incompatible!";
    00103     handleError( StkError::FUNCTION_ARGUMENT );
    00104   }
    00105 #endif
    00106
    00107   StkFloat *samples = &frames[channel];
    00108   unsigned int j, hop = frames.channels() - nChannels;
    00109   if ( nChannels == 1 ) {
    00110     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00111       *samples++ = tick();
    00112   }
    00113   else {
    00114     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00115       *samples++ = tick();
    00116       for ( j=1; j<nChannels; j++ )
    00117         *samples++ = lastFrame_[j];
    00118     }
    00119   }
    00120
    00121   return frames;
    00122 }

The documentation for this class was generated from the following file:

- HevyMetl.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.